org.apache.commons.io.comparator

## Class LastModifiedFileComparator

- java.lang.Object
- - org.apache.commons.io.comparator.LastModifiedFileComparator

- All Implemented Interfaces:
    Serializable, Comparator<File>

      public class LastModifiedFileComparator
      extends Object
      implements Serializable

  Compare the last modified date/time of two files for order (see `FileUtils.lastModifiedUnchecked(File)`).

  This comparator can be used to sort lists or arrays of files by their last modified date/time.

  Example of sorting a list of files using the `LASTMODIFIED_COMPARATOR` singleton instance:

             List<File> list = ...
             ((AbstractFileComparator) LastModifiedFileComparator.LASTMODIFIED_COMPARATOR).sort(list);

  Example of doing a reverse sort of an array of files using the `LASTMODIFIED_REVERSE` singleton instance:

             File[] array = ...
             ((AbstractFileComparator) LastModifiedFileComparator.LASTMODIFIED_REVERSE).sort(array);

  ## Deprecating Serialization

  Serialization is deprecated and will be removed in 3.0.

  Since:
    1.4
  See Also:
    Serialized Form

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static Comparator<File>` | `LASTMODIFIED_COMPARATOR` Last modified comparator instance.
    `static Comparator<File>` | `LASTMODIFIED_REVERSE` Reverse last modified comparator instance.

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `LastModifiedFileComparator()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `compare(File file1, File file2)` Compares the last modified date/time of two files.
    `File[]` | `sort(File... files)` Sorts an array of files.
    `List<File>` | `sort(List<File> files)` Sorts a List of files.
    `String` | `toString()` String representation of this file comparator.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface java.util.Comparator

      `comparing, comparing, comparingDouble, comparingInt, comparingLong, equals, naturalOrder, nullsFirst, nullsLast, reversed, reverseOrder, thenComparing, thenComparing, thenComparing, thenComparingDouble, thenComparingInt, thenComparingLong`

- - ### Field Detail

    - #### LASTMODIFIED_COMPARATOR

          public static final Comparator<File> LASTMODIFIED_COMPARATOR

      Last modified comparator instance.

    - #### LASTMODIFIED_REVERSE

          public static final Comparator<File> LASTMODIFIED_REVERSE

      Reverse last modified comparator instance.

  - ### Constructor Detail

    - #### LastModifiedFileComparator

          public LastModifiedFileComparator()

  - ### Method Detail

    - #### compare

          public int compare(File file1,
                             File file2)

      Compares the last modified date/time of two files.
      Specified by:
        `compare` in interface `Comparator<File>`
      Parameters:
        `file1` - The first file to compare.
        `file2` - The second file to compare.
      Returns:
        a negative value if the first file's last modified date/time is less than the second, zero if the last modified date/time are the same and a positive value if the first files last modified date/time is greater than the second file.

    - #### sort

          public File[] sort(File... files)

      Sorts an array of files.

      This method uses `Arrays.sort(Object[], Comparator)` and returns the original array.

      Parameters:
        `files` - The files to sort, may be null.
      Returns:
        The sorted array.
      Since:
        2.0

    - #### sort

          public List<File> sort(List<File> files)

      Sorts a List of files.

      This method uses `List.sort(Comparator)` and returns the original list.

      Parameters:
        `files` - The files to sort, may be null.
      Returns:
        The sorted list.
      Since:
        2.0

    - #### toString

          public String toString()

      String representation of this file comparator.
      Overrides:
        `toString` in class `Object`
      Returns:
        String representation of this file comparator.

Copyright © 2002–2023 The Apache Software Foundation. All rights reserved.